// COMWrapper.h : Declaration of the CCOMWrapper

#pragma once
#include "resource.h"       // main symbols



#include "CPPWrapper_COM_i.h"



#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif

using namespace ATL;


// CCOMWrapper

class ATL_NO_VTABLE CCOMWrapper :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CCOMWrapper, &CLSID_COMWrapper>,
	public IDispatchImpl<ICOMWrapper, &IID_ICOMWrapper, &LIBID_CPPWrapper_COMLib, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CCOMWrapper()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_COMWRAPPER)


BEGIN_COM_MAP(CCOMWrapper)
	COM_INTERFACE_ENTRY(ICOMWrapper)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()



	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

public:
	STDMETHOD(CreateContext)(LONGLONG* pContext);
	STDMETHOD(JavaName)(LONGLONG pContext, BSTR* buf);
	STDMETHOD(JavaCreateCustom)(LONGLONG pContext, LONG i, LONGLONG* pJavaCustom);
	STDMETHOD(JavaCreateAdder)(LONGLONG pContext, LONGLONG* pJavaAdder);
	STDMETHOD(JavaAdd)(LONGLONG pContext, LONGLONG pJavaAdder, LONG a, LONGLONG pJavaCustom, LONG* result);
	STDMETHOD(ScalaName)(LONGLONG pContext, BSTR* buf);
	STDMETHOD(ScalaCreateCustom)(LONGLONG pContext, LONG i, LONGLONG* pScalaCustom);
	STDMETHOD(ScalaCreateAdder)(LONGLONG pContext, LONGLONG* pScalaAdder);
	STDMETHOD(ScalaAdd)(LONGLONG pContext, LONGLONG pScalaAdder, LONG a, LONGLONG pScalaCustom, LONG* result);
};

OBJECT_ENTRY_AUTO(__uuidof(COMWrapper), CCOMWrapper)
