#ifndef __CONTEXT_H__
#define __CONTEXT_H__

#include <jni.h>

class Context {
	JavaVM *_jvm;
	JNIEnv *_env;

	jclass _clsJavaAdder;
	jmethodID _midJavaAdderConstructor; 
	jmethodID _midJavaAdderAdd; 
	jmethodID _midJavaAdderName;

	jclass _clsScalaAdder;
	jmethodID _midScalaAdderConstructor; 
	jmethodID _midScalaAdderAdd; 

	jclass _clsScalaAdderDollar;
	jmethodID _midScalaAdderDollarName; 

	jclass _clsJavaCustom;
	jmethodID _midJavaCustomConstructor; 
	jmethodID _midJavaCustomGet; 

	jclass _clsScalaCustom;
	jmethodID _midScalaCustomConstructor;
	jmethodID _midScalaCustomI;
public:
	Context();
	~Context();

	void *JavaCreateAdder();
	void *JavaCreateCustom(long i);
	long JavaAdd(void *pObjAdder, long a, void *pObjCustom);
	void JavaName(char *buf, int buflen);

	void *ScalaCreateAdder();
	void *ScalaCreateCustom(long i);
	long ScalaAdd(void *pObjAdder, long a, void *pObjCustom);
	void ScalaName(char *buf, int buflen);
};

#endif
